import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.util.*;

class BancoImobiliario extends JFrame implements ActionListener 
{   
   Container pane;
   Tabuleiro tabuleiro;
   ArrayList jogadores;
   DialogInicio dialogInicio;
   Dados dados;
   
   Jogador jogadorAtual;
   
   boolean partidaComecada;
   
   boolean recomecarPartida;
   boolean terminou;
   boolean jogouDados;
   boolean comecouPartida;
   
   //***********************************************************
   //*
   //* Construtor
   //*
   //*********************************************************** 
   public BancoImobiliario() throws Exception
   {            
      pane = getContentPane();                        
      
      jogadores = new ArrayList();
      dados = new Dados(this);      
      
      inicializaTabuleiro(); 
      
      dialogInicio = new DialogInicio(this,"Nova Partida",jogadores);
      
      partidaComecada = false;
      recomecarPartida = false;  
      terminou = false;   
      comecouPartida = false; 
      
      //Ouvindo 'window closing' ...
      addWindowListener ( new WindowAdapter()
      {
         public void windowClosing(WindowEvent e) { fim();}
      });

   }      

   //***********************************************************
   //*
   //* Mtodo: inicializaTabuleiro()
   //*
   //* Cria os menus
   //*
   //***********************************************************     
   public void inicializaTabuleiro() throws Exception
   {
      
      criaMenus(); 
      
      pane.setLayout(new BorderLayout());          
      
      tabuleiro = new Tabuleiro(this);                       
      tabuleiro.setBackground(Color.white);
      tabuleiro.setBorder(new BevelBorder(1));
      
      pane.add(tabuleiro,BorderLayout.CENTER);         
      
      //Inicializando parametros ...
      setTitle("Banco Imobilirio"); //... do 'JFrame'.
      setSize(1024,768); //... do 'JFrame' em pixels.           
      setVisible(true); //... este JFrame e todos os seus componentes.                                       
      
   }
     
   //***********************************************************
   //*
   //* Mtodo: criaMenus
   //*
   //* Cria os menus
   //*
   //***********************************************************   
   public void criaMenus() throws Exception
   {
   
      // CRIAO DE MENUS    
      JMenuBar barra = new JMenuBar();
    
      // MENU ARQUIVO
      JMenu jogo = new JMenu("Jogo");
      
      JMenuItem item = new JMenuItem("Novo");
      item.setActionCommand("Novo");
      item.addActionListener(this);
      jogo.add(item);    
      
      item = new JMenuItem("Sair");
      item.setActionCommand("Sair");
      item.addActionListener(this);
      jogo.add(item);    
      
      barra.add(jogo);          
    
    
      //MENU ADICIONA O MENU A JANELA
      this.setJMenuBar(barra);  
      
      
            

   }//criaMenus()
      
   
   //***********************************************************
   //*
   //* Mtodo: actionPerformed
   //*
   //* Define aes dos menus
   //*
   //***********************************************************
   public void actionPerformed(ActionEvent e)
   {
      String caseof = e.getActionCommand();
      if(caseof.equals("Sair"))
      {
         fim();
      }
      else if(caseof.equals("Novo"))
      { 
         dialogInicio.show();
         System.out.println("chegou aqui");
      }
   }
   
   //***********************************************************
   //*
   //* Mtodo: jogo  
   //*
   //* Loop principal do jogo
   //*
   //***********************************************************   
   public void comecaJogo()
   {
      jogadorAtual = (Jogador)jogadores.get(0);            
                  
      terminou = false;
      recomecarPartida = false;
      jogouDados = false;        
      
      comecouPartida = true;
            
      
   }
       
   
   //***********************************************************
   //*
   //* Mtodo: fim
   //*
   //* Fecha o programa
   //*
   //***********************************************************
   public void fim() 
   { 
      System.exit(0);
   }
   
   //***********************************************************
   //*
   //* Mtodo: main
   //*
   //***********************************************************   
   public static void main(String[] args) throws Exception
   {      
      new BancoImobiliario();
      
   }
   
}