import java.awt.*;
import javax.swing.*;
import java.awt.image.*;

class Companhia extends TabItem
{             
   String nome;
   int preco;
   ImageIcon imagem;
   ImageIcon imagemGrande;
   
   //***********************************************************
   //*
   //* construtor
   //*
   //***********************************************************     
   public Companhia(String nome, int preco,String imagem,String imagemGrande)
   {
      this.nome = nome;
      this.preco = preco;      
      this.imagem = new ImageIcon(imagem);
      this.imagemGrande = new ImageIcon(imagemGrande);
   }  
   
   //***********************************************************
   //*
   //* Mtodo: tipoItem
   //*
   //* retorna o tipo desse item do tabuleiro 
   //*
   //***********************************************************    
   public String tipoItem()
   {
      return "Companhia";
   }   

   //***********************************************************
   //*
   //* Mtodo: acao
   //*
   //* executa a ao correspondente quando o jogador cai nesse item no tabuleiro
   //*
   //***********************************************************             
   public void acao(Jogador j)
   {
      //PRIMEIRO JOGADOR A CAIR NA COMPANHIA - OPCAO DE COMPRAR
      if(dono == null)
      {         
         if(j.getDinheiro() >= this.preco)
         {
            int opcao = JOptionPane.showConfirmDialog(null,"Deseja comprar a Companhia?","",JOptionPane.YES_NO_OPTION);            
            
            if(opcao == JOptionPane.YES_OPTION)
            {
               j.removeDinheiro(this.preco);
               j.addItem(this);
               this.dono = j;
            }
         }
         else
         {
            JOptionPane.showMessageDialog(null,"Dinheiro insuficiente para comprar a Companhia");
         }
         
      }
      //PAGAR O ALUGUEL DO TERRENO
      else
      {
         if(this.dono == j)
         {
            JOptionPane.showMessageDialog(null,"Esta companhia j  sua");         
         }
         else if(this.isHipotecado())
         {
            JOptionPane.showMessageDialog(null,"Esta companhia est hipotecada"); 
         }
         else
         {  
            int valorAPagar;
            
            valorAPagar = (this.preco==150?40:50)*(j.getDado1()+j.getDado2());
            
            JOptionPane.showMessageDialog(null,"Pague R$"+valorAPagar+" de taxa para "+this.dono.getNome()); 
            j.removeDinheiro(valorAPagar);
            dono.addDinheiro(valorAPagar);
         }
         
      }      
      
   }
   
   //***********************************************************
   //*
   //* Mtodo: desenha
   //*
   //* desenha o item no tabuleiro
   //*
   //***********************************************************    
   public void desenha(Graphics g)   
   {                 
      g.setColor(Color.black);
      g.drawRect(posx+1,posy+1,59,59);
                                    
      g.drawImage(imagem.getImage(),posx+9,posy+9,new JButton());
      
      if(this.dono != null)
      {
         int tam = g.getFontMetrics().stringWidth(dono.getNome());
         
         g.setFont(new Font("Verdana",Font.PLAIN,9));
         g.drawString(dono.getNome(),posx+59-tam,posy+60);
      }
                       
   }
   
   //***********************************************************
   //*
   //* Mtodo: desenhaDetalhado
   //*
   //* desenha o item detalhado
   //*
   //***********************************************************    
   public void desenhaDetalhado(Graphics g,int x,int y)   
   {                 
      g.setColor(Color.black);
      g.drawRect(x,y,171,196);
      g.drawRect(x,y,172,197);
      
      g.drawImage(imagemGrande.getImage(),x+56,y+9,new JButton());
      
      g.setFont(new Font("Verdana",Font.BOLD,12));
      g.drawString("Pontos dos dados",x+9,y+140);
      g.drawString("multiplicados por",x+9,y+152);
      g.drawString("HIPOTECA",x+9,y+180);
      
      if(this.preco == 200)
      {
         g.drawString("50",x+150,y+152);
         g.drawString("100",x+142,y+180);
      }else
      {
         g.drawString("40",x+150,y+152); 
         g.drawString("75",x+150,y+180);
      }                                                     
   }   
}