import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.event.*;

class DialogInicio extends JDialog implements ListSelectionListener
{
   DialogInicio este;   
   JList list;
   BancoImobiliario owner;   
   DefaultListModel listModel;
   private JButton fireButton;
   private JButton hireButton;
   private JButton startButton;
   private JTextField employeeName;
   
   //***********************************************************
   //*
   //* Construtor
   //*
   //*********************************************************** 
   public DialogInicio(Frame owner,String title,ArrayList jogadores)
   {
      super(owner,title);
      this.owner = (BancoImobiliario) owner;
      this.setModal(true);      
      this.setResizable(false);
      this.setBounds(300,250,300,200);
      este = this;
      
      Container pane = getContentPane();
                  
      pane.setLayout(new BorderLayout());               
      
                              
        listModel = new DefaultListModel();     

        //Create the list and put it in a scroll pane.
        list = new JList(listModel);
        list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        list.setSelectedIndex(-1);
        list.addListSelectionListener(this);
        list.setVisibleRowCount(5);
        JScrollPane listScrollPane = new JScrollPane(list);

        hireButton = new JButton("Adicionar");
        HireListener hireListener = new HireListener(hireButton);
        hireButton.setActionCommand("Adicionar");
        hireButton.addActionListener(hireListener);
        hireButton.setEnabled(false);

        fireButton = new JButton("Excluir");
        fireButton.setActionCommand("Excluir");
        fireButton.addActionListener(new FireListener());

        employeeName = new JTextField(10);
        employeeName.addActionListener(hireListener);
        employeeName.getDocument().addDocumentListener(hireListener);
        //String name = listModel.getElementAt(
          //                    list.getSelectedIndex()).toString();

        //Create a panel that uses BoxLayout.
        JPanel buttonPane = new JPanel();
        buttonPane.setLayout(new BoxLayout(buttonPane,
                                           BoxLayout.LINE_AXIS));
        buttonPane.add(fireButton);
        buttonPane.add(Box.createHorizontalStrut(5));
        //buttonPane.add(new JSeparator(SwingConstants.VERTICAL));
        buttonPane.add(Box.createHorizontalStrut(5));
        buttonPane.add(employeeName);
        buttonPane.add(hireButton);
        buttonPane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        
        JPanel painelJogadores = new JPanel(new BorderLayout());              
        
        JPanel painelcima = new JPanel(new BorderLayout());
        
        painelcima.add(new JLabel("Jogadores"),BorderLayout.NORTH);
        painelcima.add(buttonPane,BorderLayout.CENTER);
        
                        
        JPanel painelaux = new JPanel(new BorderLayout());
        
        startButton = new JButton("Comear");
        startButton.setActionCommand("Comecar");
        startButton.addActionListener(new startListener());
        
        painelaux.add(startButton,BorderLayout.EAST);
        painelaux.add(new JLabel("   "));
        painelaux.add(fireButton,BorderLayout.WEST);
        
        JPanel painelbaixo = new JPanel(new BorderLayout());
        
        painelbaixo.add(listScrollPane,BorderLayout.CENTER);
        painelbaixo.add(painelaux,BorderLayout.SOUTH);
        

        painelJogadores.add(painelcima, BorderLayout.NORTH);
        painelJogadores.add(painelbaixo, BorderLayout.SOUTH);
                        
        
      pane.add(painelJogadores);                                           
   }
   
    //This method is required by ListSelectionListener.
    public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting() == false) {

            if (list.getSelectedIndex() == -1) {
            //No selection, disable fire button.
                fireButton.setEnabled(false);

            } else {
            //Selection, enable the fire button.
                fireButton.setEnabled(true);
            }
        }
    }   
   
    class FireListener implements ActionListener 
    {
        public void actionPerformed(ActionEvent e) {
            //This method can be called only if
            //there's a valid selection
            //so go ahead and remove whatever's selected.
            int index = list.getSelectedIndex();
            listModel.remove(index);

            int size = listModel.getSize();

            if (size == 0) { //Nobody's left, disable firing.
                fireButton.setEnabled(false);

            } else { //Select an index.
                if (index == listModel.getSize()) {
                    //removed item in last position
                    index--;
                }

                list.setSelectedIndex(index);
                list.ensureIndexIsVisible(index);
            }
        }
    }

    //This listener is shared by the text field and the hire button.
    class HireListener implements ActionListener, DocumentListener 
    {
        private boolean alreadyEnabled = false;
        private JButton button;

        public HireListener(JButton button) {
            this.button = button;
        }

        //Required by ActionListener.
        public void actionPerformed(ActionEvent e) {
            String name = employeeName.getText();

            //User didn't type in a unique name...
            if (name.equals("") || alreadyInList(name)){
                Toolkit.getDefaultToolkit().beep();
                employeeName.requestFocusInWindow();
                employeeName.selectAll();
                return;
            }
            //
            else if(listModel.getSize() == 8)
            {
               JOptionPane.showMessageDialog(este,"O Jogo pode ter no mximo 8 jogadores");
               return;
            }
            

            int index = list.getSelectedIndex(); //get selected index
            if (index == -1) { //no selection, so insert at beginning
                index = 0;
            } else {           //add after the selected item
                index++;
            }

            listModel.insertElementAt(employeeName.getText(), index);
            //If we just wanted to add to the end, we'd do this:
            //listModel.addElement(employeeName.getText());

            //Reset the text field.
            employeeName.requestFocusInWindow();
            employeeName.setText("");

            //Select the new item and make it visible.
            list.setSelectedIndex(index);
            list.ensureIndexIsVisible(index);
        }   
           //This method tests for string equality. You could certainly
        //get more sophisticated about the algorithm.  For example,
        //you might want to ignore white space and capitalization.
        protected boolean alreadyInList(String name) {
            return listModel.contains(name);
        }

        //Required by DocumentListener.
        public void insertUpdate(DocumentEvent e) {
            enableButton();
        }

        //Required by DocumentListener.
        public void removeUpdate(DocumentEvent e) {
            handleEmptyTextField(e);
        }

        //Required by DocumentListener.
        public void changedUpdate(DocumentEvent e) {
            if (!handleEmptyTextField(e)) {
                enableButton();
            }
        }

        private void enableButton() {
            if (!alreadyEnabled) {
                button.setEnabled(true);
            }
        }

        private boolean handleEmptyTextField(DocumentEvent e) {
            if (e.getDocument().getLength() <= 0) {
                button.setEnabled(false);
                alreadyEnabled = false;
                return true;
            }
            return false;
        }
    }
    
    
    class startListener implements ActionListener 
    {
        public void actionPerformed(ActionEvent e) {

            int size = listModel.getSize();

            if (size < 2) { 
               JOptionPane.showMessageDialog(este,"So necessrios no mnimo dois jogadores") ;              
            }else{ 
            
               owner.jogadores.clear();
               
               Jogador anterior = new Jogador("",0,Color.black,new Inicio());
               Jogador atual = new Jogador("",0,Color.black,new Inicio());
                              
               for(int x = 0;x < listModel.size();x++)
               {
                  String nome = (String)listModel.getElementAt(x);
                  
                  //EscolheCores();
                  Color cor = Color.GRAY;
                  switch(x)
                  {
                     case 0:{ cor = Color.BLUE; break;}
                     case 1:{ cor = Color.RED; break;}
                     case 2:{ cor = Color.YELLOW; break;}
                     case 3:{ cor = Color.GREEN; break;}
                     case 4:{ cor = Color.CYAN; break;}
                     case 5:{ cor = Color.GRAY; break;}
                     case 6:{ cor = Color.PINK; break;}
                     case 7:{ cor = Color.MAGENTA; break;}
                     case 8:{ cor = Color.ORANGE; break;}
                  }
                  
                  atual = new Jogador(nome,2458,cor,owner.tabuleiro.getItemIni());                  
                  owner.jogadores.add(atual);                  
                  anterior.setProximo(atual);
                  anterior = atual;
               }   
               
               atual.setProximo((Jogador)owner.jogadores.get(0));
               
               este.hide();
               owner.repaint();
               
               owner.recomecarPartida = true;
               
               owner.comecaJogo();
            }            
          }
     }
    

      
}