import java.awt.*;
import java.util.*;
import javax.swing.*;


class Jogador extends Component
{
   private String nome;
   private int dinheiro;
   private Color cor;
   private Jogador proximo;
   private TabItem posicaoAtual;
   private TabItem posicaoInicial;
   private int dado1,dado2;
   private boolean tapreso;
   private int rodadasPreso;
      
   ArrayList itens;
   
   //***********************************************************
   //*
   //* Construtor
   //*
   //*********************************************************** 
   public Jogador(String nome,int dinheiro,Color cor,TabItem posicaoInicial)
   {      
      this.nome = nome;
      this.dinheiro = dinheiro;
      this.cor = cor;
      this.posicaoAtual = posicaoInicial;
      this.posicaoInicial = posicaoInicial;
      this.tapreso = false;
      this.rodadasPreso = 0;
      
      posicaoAtual.estaciona(this);
      
      itens = new ArrayList();
   }
  
   //***********************************************************
   //*
   //* Mtodo setNome
   //*
   //***********************************************************  
   public Jogador setNome(String nome)
   {
      this.nome = nome;      
      return this;
   }
   
   //***********************************************************
   //*
   //* Mtodo getNome
   //*
   //*********************************************************** 
   public String getNome()
   {
      return this.nome;      
   }
   
   //***********************************************************
   //*
   //* Mtodo setDinheiro
   //*
   //***********************************************************    
   public Jogador setDinheiro(int dinheiro)
   {
      this.dinheiro = dinheiro;
      return this;
   }
   
   //***********************************************************
   //*
   //* Mtodo getDinheiro
   //*
   //*********************************************************** 
   public int getDinheiro()
   {
      return this.dinheiro;
   }
      
   //***********************************************************
   //*
   //* Mtodo addDinheiro
   //*
   //*********************************************************** 
   public Jogador addDinheiro(int dinheiro)
   {
      this.dinheiro += dinheiro;
      return this;
   }
   
   //***********************************************************
   //*
   //* Mtodo removeDinheiro
   //*
   //*********************************************************** 
   public Jogador removeDinheiro(int dinheiro)
   {
      this.dinheiro -= dinheiro;
      return this;
   }
   
   //***********************************************************
   //*
   //* Mtodo setCor
   //*
   //*********************************************************** 
   public Jogador setCor(Color cor)
   {
      this.cor = cor;
      return this;
   }
   
   //***********************************************************
   //*
   //* Mtodo getCor
   //*
   //*********************************************************** 
   public Color getCor()
   {
      return this.cor;
   }
   
   //***********************************************************
   //*
   //* Mtodo addItem
   //*
   //*********************************************************** 
   public Jogador addItem(TabItem novoItem)
   {
      itens.add(novoItem);
      return this;
   }
   
   //***********************************************************
   //*
   //* Mtodo removeItem
   //*
   //*********************************************************** 
   public Jogador removeItem(TabItem item)
   {
      itens.remove(itens.indexOf(item));
      return this;
   }
   
   //***********************************************************
   //*
   //* Mtodo setProximo
   //*
   //*********************************************************** 
   public Jogador setProximo(Jogador proximo)
   {
      this.proximo = proximo;   
      return this;
   }
   
   //***********************************************************
   //*
   //* Mtodo getProximo
   //*
   //***********************************************************    
   public Jogador getProximo()
   {
      return this.proximo;
   }
   
   //***********************************************************
   //*
   //* Mtodo anda
   //*
   //***********************************************************       
   public Jogador anda(int dado1,int dado2)
   {      
      
      posicaoAtual.desestaciona(this);            
      
      for(int cont=0;cont<dado1+dado2;cont++)
      {
         this.posicaoAtual = this.posicaoAtual.getProximo();
         
         //SE PASSOU PELO PONTO DE PARTIDA RECEBE 200
         if(this.posicaoAtual == posicaoInicial)
         {
            //JOptionPane.showMessageDialog(null,"Passou pelo Ponto de Partida, Receba 200");
            this.addDinheiro(200);
         }
      }
      
      posicaoAtual.estaciona(this);
      
      return this;
   }
   
   //***********************************************************
   //*
   //* Mtodo getPosicaoAtual
   //*
   //***********************************************************    
   public TabItem getPosicaoAtual()
   {
      return this.posicaoAtual;
   }
   
   //***********************************************************
   //*
   //* Mtodo setPosicaoAtual
   //*
   //*********************************************************** 
   public Jogador setPosicaoAtual(TabItem pos)
   {
      //posicaoAtual.desestaciona(this);
      this.posicaoAtual = pos;
      return this;
   }   
   
   //***********************************************************
   //*
   //* Mtodo getNumTerrenos
   //*
   //***********************************************************       
   public int getNumTerrenos()
   {
      return this.itens.size();
   }
   
   //***********************************************************
   //*
   //* Mtodo getDado1
   //*
   //***********************************************************       
   public int getDado1()
   {
      return this.dado1;
   }   

   //***********************************************************
   //*
   //* Mtodo getDado2
   //*
   //***********************************************************       
   public int getDado2()
   {
      return this.dado2;
   }   
   
   //***********************************************************
   //*
   //* Mtodo setDado1
   //*
   //***********************************************************       
   public void setDado1(int d1)
   {
      this.dado1 = d1;
   }   

   //***********************************************************
   //*
   //* Mtodo setDado2
   //*
   //***********************************************************       
   public void setDado2(int d2)
   {
      this.dado2 = d2;
   }       
   
   //***********************************************************
   //*
   //* Mtodo estaPreso
   //*
   //***********************************************************       
   public boolean estaPreso()
   {
      return this.tapreso;
   }       
   
   //***********************************************************
   //*
   //* Mtodo prende
   //*
   //***********************************************************       
   public void setPreso(boolean preso)
   {
      this.tapreso = preso;
   }
   
   public void setRodadasPreso(int rodadas)       
   {
   	  this.rodadasPreso = rodadas;
   }
   
   public int getRodadasPreso()
   {
   	  return this.rodadasPreso;
   }
      
      
   
  

}