import java.awt.*;
import java.util.*;

abstract class TabItem
{      
   String nome;
   int preco;
   TabItem proximo;
   int posx;
   int posy;
   Jogador dono;
   ArrayList estacionamento = new ArrayList();
   boolean hipotecado;
   
   abstract public String tipoItem();   
   abstract public void acao(Jogador j);
   abstract public void desenha(Graphics g);         
   
   public void desenhaDetalhado(Graphics g,int x,int y){};



   //***********************************************************
   //*
   //* Mtodo desenhaNoTabuleiro
   //*
   //***********************************************************  
   public void desenhaNoTabuleiro(Graphics g)
   {
      desenha(g);
      
      //Desenha o estacionamento;
      for(int cont=0;cont<estacionamento.size();cont++)
      {
         g.setColor(((Jogador)estacionamento.get(cont)).getCor());
         
         int x,y;
         
         x = (int) cont/3;
         y = cont%3;
         
         g.fillRect(posx+5+(x*20),posy+20+(y*12),15,10);
         g.setColor(Color.BLACK);
         g.drawRect(posx+5+(x*20),posy+20+(y*12),15,10);
         
      }      
      
   }

   

   //***********************************************************
   //*
   //* Mtodo setProximo
   //*
   //***********************************************************          
   public void setProximo(TabItem proximo)
   {
      this.proximo = proximo;
   }

   //***********************************************************
   //*
   //* Mtodo getProximo
   //*
   //***********************************************************          
   public TabItem getProximo()
   {
      return this.proximo;
   }   
 
   //***********************************************************
   //*
   //* Mtodo setPos
   //*
   //***********************************************************         
   public void setPos(int x,int y)
   {
      this.posx = x;
      this.posy = y;
   }

   //***********************************************************
   //*
   //* Mtodo getPos
   //*
   //***********************************************************          
   public int getPosX()
   {
      return posx;
   }

   //***********************************************************
   //*
   //* Mtodo getPosY
   //*
   //***********************************************************          
   public int getPosY()
   {
      return posy;      
   }

   //***********************************************************
   //*
   //* Mtodo setDono
   //*
   //***********************************************************          
   public void setDono(Jogador dono)
   {
      this.dono = dono;
   }

   //***********************************************************
   //*
   //* Mtodo getDono
   //*
   //***********************************************************          
   public Jogador getDono()
   {
      return this.dono;
   }

   //***********************************************************
   //*
   //* Mtodo contemPonto
   //*
   //***********************************************************          
   public boolean contemPonto(int x,int y)
   {
      if(x-posx >0 && x-posx <59 && y-posy >0 && y-posy<59)
         return true;
      
      return false;      
   }   
   
   //***********************************************************
   //*
   //* Mtodo estaciona
   //*
   //***********************************************************          
   public void estaciona(Jogador jogador)
   {
      estacionamento.add(jogador);
   }
   
   //***********************************************************
   //*
   //* Mtodo desestaciona
   //*
   //***********************************************************          
   public void desestaciona(Jogador jogador)
   {
      estacionamento.remove(estacionamento.indexOf(jogador));
   }
   
   //***********************************************************
   //*
   //* Mtodo setHipotecado
   //*
   //***********************************************************          
   public void setHipotecado(boolean hipotecado)
   {
      this.hipotecado = hipotecado;
   }
   
   //***********************************************************
   //*
   //* Mtodo isHipotecado
   //*
   //***********************************************************          
   public boolean isHipotecado()
   {
      return this.hipotecado;
   }
   
      
      
   
}