import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;

class Tabuleiro extends JPanel
{   
   ArrayList tabItens;
   TabItem itemIni;   
   TabItem prisao;
   BancoImobiliario owner;   
   
   final int DESLOCAMENTO_X = 15;
   final int DESLOCAMENTO_Y = 15;
   
   ImageIcon imgSeta = new ImageIcon("seta.gif");
         
   private int x,y; //POSICAO DO ULTIMO CLIQUE.
   
   private Exception ex;
            
   //***********************************************************
   //*
   //* Construtor
   //*
   //*********************************************************** 
   public Tabuleiro(BancoImobiliario owner) throws Exception
   {      
      super();
      this.owner = owner;
      System.out.println("entrou no construtor");      
      addListener();     
      criaItens();               
   }
      
   //***********************************************************
   //*
   //* Mtodo: addListener
   //*
   //* Adiciona o Listener de mouse para capturar os cliques no tabuleiro
   //*
   //*********************************************************** 
   private void addListener() throws Exception
   {  
        
      addMouseListener ( new MouseAdapter()
                             {
                                 //Redefinindo acao para 'mouseClicked' ...
                                 public void mouseClicked(MouseEvent e) 
                                 {
                                    try{
                                       processaClique(e.getX(),e.getY());                                    
                                    }catch(Exception exc){
                                       ex = exc;
                                       System.out.println(ex.getMessage());
                                    };
                                 }
                              }); 
      if(!(ex == null))
         throw(ex);
   }   

   //***********************************************************
   //*
   //* Mtodo: criaItens
   //*
   //* Cria os itens do tabuleiro e adiciona-os a lista;
   //*
   //***********************************************************    
   private void criaItens()
   {
      tabItens = new ArrayList();
      
      TabItem novo = new Terreno("","",Color.black,0,0,0,0,0,0,0,0),
              anterior = new Terreno("","",Color.black,0,0,0,0,0,0,0,0);
      
      for(int numItem=0; numItem < 40; numItem++)
      {        
      
         //INICIO
         if(numItem == 0)
         {
            novo = new Inicio();
         }
         //SORTE REVS
         else if(numItem == 2 || numItem == 12 || numItem == 16 || numItem == 22 || numItem == 27 || numItem == 37)
         {
            novo = new SorteReves();
         }
         //PRISO
         else if(numItem == 10)
         {
            novo = new Prisao();
            prisao = novo;
         }
         //LUCROS OU DIVIDENDOS
         else if(numItem == 18)
         {
            novo = new LucrosOuDividendos();
         }
         //IMPOSTO DE RENDA
         else if(numItem == 24)
         {
            novo = new ImpostoDeRenda();
         }
         //PARADA LIVRE
         else if(numItem == 20)
         {
            novo = new ParadaLivre();
         }
         //VA PARA A PRISO
         else if(numItem == 30)
         {
            novo = new VaParaAPrisao(prisao);
         }         
         //COMPANHIAS
         else if(numItem == 5 || numItem == 7 || numItem == 15 || numItem ==  25 || numItem == 32 || numItem == 35)
         {
            //FERROVIARIA
            if(numItem==5){
               novo = new Companhia("Ferroviria",200,"CompanhiaFerroviaria.gif","CompanhiaFerroviariaGrande.gif");
            //VIAO
            }else if(numItem==7){
               novo = new Companhia("Viao",200,"CompanhiaDeViacao.gif","CompanhiaDeViacaoGrande.gif");               
            //TAXI
            }else if(numItem==15){
               novo = new Companhia("Taxi",150,"CompanhiaDeTaxi.gif","CompanhiaDeTaxiGrande.gif");               
            //NAVEGAAO               
            }else if(numItem==25){
               novo = new Companhia("Navegao",150,"CompanhiaDeNavegacao.gif","CompanhiaDeNavegacaoGrande.gif");                              
            //AVIACAO
            }else if(numItem==32){
               novo = new Companhia("Aviao",200,"CompanhiaDeAviacao.gif","CompanhiaDeAviacaoGrande.gif");                                          
            //TAXI AREO
            }else if(numItem==35){
               novo = new Companhia("Taxi Areo",200,"CompanhiaDeTaxiAereo.gif","CompanhiaDeTaxiAereoGrande.gif");               
            }
            
         }
         //TERRENO
         else
         {
            if(numItem==1){
               novo = new Terreno("Leblon","",new Color(230,0,255),100,6,30,90,270,400,500,50);
            }else if(numItem==3){
               novo = new Terreno("Presidente","Vargas",new Color(230,0,255),60,2,10,30,90,160,250,50);
            }else if(numItem==4){
               novo = new Terreno("Nsa Sra de","Copacabana",new Color(230,0,255),60,4,20,60,180,320,450,50);
            }else if(numItem==6){
               novo = new Terreno("Brigadeiro","Faria Lima",new Color(0,144,255),240,20,100,300,750,925,1100,150);
            }else if(numItem==8){
               novo = new Terreno("Rebouas","",new Color(0,144,255),220,18,90,250,700,875,1050,150);
            }else if(numItem==9){
               novo = new Terreno("9 de Julho","",new Color(0,144,255),200,18,90,250,700,875,1050,150);
            }else if(numItem==11){
               novo = new Terreno("Av Europa","",new Color(100,0,255),200,16,80,220,600,800,1000,100);
            }else if(numItem==13){
               novo = new Terreno("Rua","Augusta",new Color(100,0,255),180,14,70,200,550,750,950,100);
            }else if(numItem==14){
               novo = new Terreno("Pacaemb","",new Color(100,0,255),180,14,70,200,550,750,950,100);
            }else if(numItem==17){
               novo = new Terreno("Ingerlagos","",new Color(255,115,0),350,35,175,500,1100,1300,1500,200);
            }else if(numItem==19){
               novo = new Terreno("Morumbi","",new Color(255,115,0),400,50,200,600,1400,1700,2000,200);
            }else if(numItem==21){
               novo = new Terreno("Flamengo","",new Color(255,0,0),120,8,40,100,300,450,600,50);
            }else if(numItem==23){
               novo = new Terreno("Botafogo","",new Color(255,0,0),100,6,30,90,270,400,500,50);
            }else if(numItem==26){
               novo = new Terreno("Av Brasil","",new Color(255,255,0),160,12,60,180,500,700,900,100);
            }else if(numItem==28){
               novo = new Terreno("Av Paulista","",new Color(255,255,0),140,10,50,150,450,625,750,100);
            }else if(numItem==29){
               novo = new Terreno("Jardim","Europa",new Color(255,255,0),140,10,50,150,450,625,750,100);
            }else if(numItem==31){
               novo = new Terreno("Copacabana","",new Color(50,140,25),260,22,110,330,800,975,1150,150);
            }else if(numItem==33){
               novo = new Terreno("Av Vieira","Souto",new Color(50,140,25),320,28,150,450,1000,1200,1400,200);
            }else if(numItem==34){
               novo = new Terreno("Av Atlntica","",new Color(50,140,25),300,26,130,390,900,1100,1275,200);
            }else if(numItem==36){
               novo = new Terreno("Ipanema","",new Color(50,140,25),300,26,130,390,900,1100,1275,200);
            }else if(numItem==38){
               novo = new Terreno("Jardim","Paulista",new Color(14,69,247),280,24,120,360,850,1025,1200,150);
            }else if(numItem==39){
               novo = new Terreno("Brooklin","",new Color(14,69,247),260,22,110,330,800,975,1150,150);
            }else         
               novo = new Terreno("Terreno","teste",                               
                                  new Color((int)(Math.random()*255),(int)(Math.random()*255),(int)(Math.random()*255)),
                                  (int)(Math.random()*20) * 100,0,0,0,0,0,0,0
                                  );                                                                                              
         }
         
         
         //Calcula a posicao XY do item na tela
         int posXY[];         
         posXY = calculaPosicaoTela(numItem);
         novo.setPos(posXY[0],posXY[1]);         

         //Liga um "casa" a sua proxima no tabuleiro
         if(numItem==0)
            itemIni = novo;         
         else
            anterior.setProximo(novo);
           
         //adiciona a "casa" a lista do tabuleiro
         tabItens.add(novo);         
         anterior = novo;                                  
      }
      
      novo.setProximo(itemIni);
            
      
   }
   
   //***********************************************************
   //*
   //* Mtodo: calculaPosicaoTela
   //*
   //* Verifica a posio do click do mouse e executa a tarefa
   //*
   //***********************************************************      
   public int[] calculaPosicaoTela(int numItem)
   {
      int posx=0,posy=0;
     
      if(numItem<11)
      {
         posx = numItem*59;
         posy = 0;
      }
      else if(numItem < 20)
      {
         posx = 10*59;
         posy = (numItem-10)*59;
      }
      else if(numItem < 30)
      {
         posx = 590-((numItem-20)*59);
         posy = 10*59;            
      }
      else
      {
         posx = 0;            
         posy = 590-((numItem-30)*59);
      }                         
      
      //DESLOCAMENTO NA TELA
      posx += DESLOCAMENTO_X;
      posy += DESLOCAMENTO_Y;
      
      int[] posXY = new int[2];
      
      posXY[0] = posx;
      posXY[1] = posy;
      
      return posXY;      
   }
   

   //***********************************************************
   //*
   //* Mtodo: processaClique
   //*
   //* Verifica a posio do click do mouse e executa a tarefa
   //*
   //***********************************************************   
   public void processaClique(int x, int y) throws Exception
   {                    
      //repaint();               
                               
      for(int z=0;z<tabItens.size();z++)
      {
         TabItem item = (TabItem)tabItens.get(z);
         if( item.contemPonto(x,y) )
         {            
            
            DialogDetalheItem dialog = new  DialogDetalheItem(item);            
            dialog.setBounds(300,250,dialog.getWidth(),dialog.getHeight());
            
            if(owner.comecouPartida)
            {
               if(item.tipoItem().compareTo("Terreno") == 0 || item.tipoItem().compareTo("Companhia") == 0)
               {
                  if(item.dono != null){
                     dialog.setTitle("Dono: "+item.dono.getNome());                  
                  }else{                  
                     dialog.setTitle("A venda");
                  }
               }
            }
            
            dialog.show();
            
            break;
         }
      }                               
      
      //CLICOU NO JOGA DADOS
      if(x-431 >0 && x-431 <123 && y-268 >0 && y-268<29)
      {
         owner.dados.sorteiaDados(); 
         owner.tabuleiro.repaint();

         if (owner.comecouPartida)
         {
            int d1 = owner.dados.getDado1();
            int d2 = owner.dados.getDado2();

            owner.jogadorAtual.setDado1(d1);
            owner.jogadorAtual.setDado2(d2);

            if(!owner.jogadorAtual.estaPreso())
            {
               owner.jogadorAtual.anda(d1,d2);                        
            }            
            
            owner.jogadorAtual.getPosicaoAtual().acao(owner.jogadorAtual);
            
            if(d1 != d2)
            {
               owner.jogadorAtual = owner.jogadorAtual.getProximo();
            }
               
         }
         
         this.repaint();
      }
      
      this.x = x;
      this.y = y;      
   }
      

   public void paintBorder(Graphics g)
   {
   }

   //***********************************************************
   //*
   //* Mtodo: paintComponent
   //*
   //* Usado para desenhar o Tabuleiro na tela
   //*
   //***********************************************************    
   public void paintComponent(Graphics g)
   {        
      super.paintComponent(g);
      
      paintTabuleiro(g);
      
      paintJogadores(g);
      
      paintDados(g);

      paintDetalhesItemAtual(g);
                                         
   }
   
   //***********************************************************
   //*
   //* Mtodo: paintTabuleiro
   //*
   //* Usado para desenhar o Tabuleiro na tela
   //*
   //***********************************************************  
   public void paintTabuleiro(Graphics g)
   {
     //Desenha a borda do tabuleiro
      g.setColor(Color.black);      
      g.fillRect(13,13,655-1,655-1);
      //Pinta de amarelo
      g.setColor(new Color(252,242,156));
      g.fillRect(16,16,649-1,649-1);
      
      
      //Desenha cada "casa" do tabuleiro
      for(int x=0;x<tabItens.size();x++)
      {                                                                          
         ((TabItem)(tabItens.get(x))).desenhaNoTabuleiro(g);                  
      }      
            
      
      Graphics2D g2d = (Graphics2D)g;                
      g2d.setFont(new Font("Verdana", Font.PLAIN, 70));          
      g2d.setColor(Color.black); 
      g2d.rotate(Math.PI/4,0,-70);                  
      g2d.drawString("Banco Imobilirio", 210, 0);       
   }

   //***********************************************************
   //*
   //* Mtodo: paintJogadores
   //*
   //* Usado para desenhar as informaes dos jogadores na tela
   //*
   //***********************************************************  
   public void paintJogadores(Graphics g)
   {
      if(owner.jogadores != null)
      {
         Graphics2D g2d = (Graphics2D)g;
         g2d.rotate(Math.PI/4*-1,0,0);
                  
         g2d.setColor(Color.GRAY);
         g2d.fillRect(750,40,288,21);
         
         g2d.setColor(Color.WHITE);
         g2d.setFont(new Font("Verdana",Font.BOLD,12));
         g2d.drawString("Jogador",781,55);         
         g2d.drawString("Propriedades",882,55);
         g2d.drawString("R$",1000,55);
            
         for(int x =0;x<owner.jogadores.size();x++)         
         {                        
            g2d.setColor(((Jogador)owner.jogadores.get(x)).getCor());
            g2d.fillRect(750,71+(27*x),25,17);
            g2d.setColor(Color.BLACK);            
            g2d.drawRect(750,71+(27*x),25,17);
                     
            g2d.drawString(((Jogador)owner.jogadores.get(x)).getNome(),780,(27*x)+85);
            
            int valor = ((Jogador)owner.jogadores.get(x)).getDinheiro();            
            String str = new Integer(valor).toString();
            int tam = g.getFontMetrics().stringWidth(str);
            
            g2d.drawString(str,1034-tam,(27*x)+85);
            
            valor = ((Jogador)owner.jogadores.get(x)).getNumTerrenos();
            str = new Integer(valor).toString();
            tam = g.getFontMetrics().stringWidth(str);
            
            g2d.drawString(str,926-tam/2,(27*x)+85);
            
            if(owner.jogadores.get(x) == owner.jogadorAtual)
            {
               g2d.drawImage(imgSeta.getImage(),725,74+(27*x),new JButton());
            }
            

            
            //g2d.drawString(((Jogador)owner.jogadores.get(x)).getDinheiro(),850,(30*x)+50);
         }

      }
      
   }
   
   //***********************************************************
   //*
   //* Mtodo: paintDados
   //*
   //* Usado para desenhar os dados
   //*
   //***********************************************************        
   public void paintDados(Graphics g)
   {
      owner.dados.desenha(g);
   }

   //***********************************************************
   //*
   //* Mtodo: paintItemAtual
   //*
   //* Usado para desenhar as informaes da casa atual onde o jogador cai...
   //*
   //***********************************************************       
   public void paintDetalhesItemAtual(Graphics g)
   {
      if(owner.comecouPartida)
      {
         owner.jogadorAtual.getPosicaoAtual().desenhaDetalhado(g,750,500);
      }      
      
   }
   
   //***********************************************************
   //*
   //* Mtodo: getItemIni      
   //*
   //***********************************************************      
   public TabItem getItemIni()
   {
      return this.itemIni;
   }
   
   //***********************************************************
   //*
   //* Mtodo: getPrisao      
   //*
   //***********************************************************      
   public TabItem getPrisao()
   {
      return this.prisao;
   }   
      
  
}