import java.awt.*;
import javax.swing.*;

class Terreno extends TabItem
{
   Color cor;
   String nome_l1;
   String nome_l2;
   
   boolean hipotecado;
      
   int preco,
       aluguel,
       comcasa1,
       comcasa2,
       comcasa3,
       comcasa4,
       comhotel,
       cadacasa;
       
      
   //***********************************************************
   //*
   //* construtor
   //*
   //***********************************************************     
   public Terreno(String nome_l1,String nome_l2,Color cor,int preco,int aluguel,
                  int c1,int c2,int c3,int c4,int h,int casa)
   {
      this.nome_l1 = nome_l1;
      this.nome_l2 = nome_l2;      
      this.cor = cor;              
      this.preco = preco;
      this.aluguel = aluguel;
      this.comcasa1 = c1;
      this.comcasa2 = c2;
      this.comcasa3 = c3;
      this.comcasa4 = c4;
      this.comhotel = h;
      this.cadacasa = casa;
      
   }   
   
   
   //***********************************************************
   //*
   //* Mtodo: tipoItem
   //*
   //* retorna o tipo desse item do tabuleiro 
   //*
   //***********************************************************    
   public String tipoItem()
   {
      return "Terreno";
   }   

   //***********************************************************
   //*
   //* Mtodo: acao
   //*
   //* executa a ao correspondente quando o jogador cai nesse item no tabuleiro
   //*
   //***********************************************************             
   public void acao(Jogador j)
   {      
      //PRIMEIRO JOGADOR A CAIR NO TERRENO - OPCAO DE COMPRAR
      if(dono == null)
      {         
         if(j.getDinheiro() >= this.preco)
         {
            int opcao = JOptionPane.showConfirmDialog(null,"Deseja comprar o terreno?","",JOptionPane.YES_NO_OPTION);            
            
            if(opcao == JOptionPane.YES_OPTION)
            {
               j.removeDinheiro(this.preco);
               j.addItem(this);
               this.dono = j;
            }
         }
         else
         {
            JOptionPane.showMessageDialog(null,"Dinheiro insuficiente para comprar o terreno");
         }
         
      }
      //PAGAR O ALUGUEL DO TERRENO
      else
      {
         if(this.dono == j)
         {
            JOptionPane.showMessageDialog(null,"Este terreno j  seu");         
         }
         else if(this.isHipotecado())
         {
            JOptionPane.showMessageDialog(null,"Este terreno est hipotecado"); 
         }
                  
         else
         {         
            JOptionPane.showMessageDialog(null,"Pague R$"+this.aluguel+" de aluguel para "+this.dono.getNome()); 
            j.removeDinheiro(this.aluguel);
            dono.addDinheiro(this.aluguel);
         }
         
      }
      
   }
   
   //***********************************************************
   //*
   //* Mtodo: desenha
   //*
   //* desenha o item no tabuleiro
   //*
   //***********************************************************    
   public void desenha(Graphics g)   
   {
      g.setColor(Color.black);
      g.drawRect(posx+1,posy+1,59,59);
      g.drawRect(posx+5,posy+5,50,15);
      g.setColor(cor);
      g.fillRect(posx+6,posy+6,49,14);
      

      g.setFont(new Font("Verdana", Font.PLAIN, 9));
      g.setColor(Color.black);
      
      if(this.dono != null)      
      {
         int tam = g.getFontMetrics().stringWidth(dono.getNome());
         g.drawString(dono.getNome(),posx+(int)(31-tam/2),posy+15);
      }
      
      
      g.setFont(new Font("Verdana", Font.PLAIN, 9));
      g.setColor(Color.black);
      
      
      int deslVertical = 0;
      if(nome_l2.compareTo("") == 0)
         deslVertical = 5;
      
      
      int tamNomel1 = g.getFontMetrics().stringWidth(nome_l1);
      g.drawString(nome_l1,posx+(int)(31-tamNomel1/2),posy+32+deslVertical);
      
      int tamNomel2 = g.getFontMetrics().stringWidth(nome_l2);
      g.drawString(nome_l2,posx+(int)(31-tamNomel2/2),posy+42);
            
      int tamStrPreco = g.getFontMetrics().stringWidth("R$ " + new Integer(preco).toString());      
      
      g.drawString("R$ " + new Integer(preco).toString(),posx+(int)(30-tamStrPreco/2),posy+55);                  
   }
   
   //***********************************************************
   //*
   //* Mtodo: desenhaDetalhado
   //*
   //* desenha o item detalhado
   //*
   //***********************************************************    
   public void desenhaDetalhado(Graphics g,int x,int y)   
   {                 
      g.setColor(Color.black);
      g.drawRect(x,y,171,196);
      g.drawRect(x,y,172,197);            
      
      g.fillRect(x+9,y+9,153,40);
      g.setColor(this.cor);
      g.fillRect(x+11,y+11,149,36);            
      
      
      //NOME DO TERRENO
      g.setFont(new Font("Verdana",Font.BOLD,12));      
      
      g.setColor(Color.black);
      int deslVertical = 0;
      if(nome_l2.compareTo("") == 0)
         deslVertical = 7;
            
      int tamNomel1 = g.getFontMetrics().stringWidth(nome_l1);
      g.drawString(nome_l1,x+(int)(86-tamNomel1/2),y+30+deslVertical);
      
      int tamNomel2 = g.getFontMetrics().stringWidth(nome_l2);
      g.drawString(nome_l2,x+(int)(86-tamNomel2/2),y+42);
      
      //OUTRAS INFORMACOES
      g.setFont(new Font("Verdana",Font.PLAIN,12));           
      
      String str = "ALUGUEL";
      int tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+(int)(86-tamStr/2),y+65);
      str = String.valueOf(this.aluguel);
      tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+171-11-tamStr,y+65);      
      
      g.drawString("C/ 1 CASA",x+9,y+80);
      str = String.valueOf(this.comcasa1);
      tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+171-11-tamStr,y+80);      
      
      g.drawString("C/ 2 CASAS",x+9,y+92);
      str = String.valueOf(this.comcasa2);
      tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+171-11-tamStr,y+92);      
      
      g.drawString("C/ 3 CASAS",x+9,y+104);
      str = String.valueOf(this.comcasa3);
      tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+171-11-tamStr,y+104);
            
      g.drawString("C/ 4 CASAS",x+9,y+117);
      str = String.valueOf(this.comcasa4);
      tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+171-11-tamStr,y+117);
      
      g.drawString("C/ HOTEL",x+9,y+129);
      str = String.valueOf(this.comhotel);
      tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+171-11-tamStr,y+129);            
      
      g.drawString("CADA CASA",x+9,y+146);
      str = String.valueOf(this.cadacasa);
      tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+171-11-tamStr,y+146);
                 
      g.drawString("HOTEL",x+9,y+158);
      str = String.valueOf(this.cadacasa);
      tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+171-11-tamStr,y+158);

      
      g.drawString("HIPOTECA",x+9,y+175);
      str = String.valueOf(this.preco/2);
      tamStr = g.getFontMetrics().stringWidth(str);
      g.drawString(str,x+171-11-tamStr,y+175);                                    
                                                                      
   }        
}